-- ================================================================================
--   Created on    :  25/01/2003
--   Programador   :  Renata Diniz
--  @C:\WIN_V4\SQL\END_CONV\ORACLE\8652_VMNSTPO.SQL
-- ================================================================================
-- ROTINA CHAMADA DA GERA_MAPA_ABASTECIMENTO E DO PROGRAMA DE CALCULO DA PREVISAO
-- DE CONSUMO
-- P_TIPOTABELA = M - GRAVA A COMPOSICAO DO PRODUTO NA TABELA RECITEMAPABA DO MAPA
--                P - GRAVA A COMPOSICAO NA TABELA DE PREVISAO DE ABASTECIMENTO (requisio)
--                C - GRAVA A COMPOSICAO NA TABELA DE PREVISAO DE CONSUMO
--                A - GRAVA A COMPOSICAO DO PRODUTO NA TABELA ITABASTEROTA
--                E - GRAVA A COMPOSIO DO PRODUTO NA ITPREVABASEV
-- ================================================================================
CREATE OR REPLACE PROCEDURE INSERE_ITEMPREV(
   P_CDFILIAL      IN ITPREVABASEV.CDFILIAL%TYPE,
   P_NRPREVABASEV  IN ITPREVABASEV.NRPREVABASEV%TYPE,
   P_NRMAPABASEV   IN MAPABASEV.NRMAPABASEV%TYPE,
   P_CDPRODUTO     IN PRODUTO.CDPRODUTO%TYPE,
   P_QTPRODUTO     IN NUMBER,
   P_TIPOTABELA    IN VARCHAR2,
   P_DTPREVENDVMN  IN PREVCONSVMN.DTPREVENDVMN%TYPE,
   P_NRABASTEROTA  IN ABASTEROTA.NRABASTEROTA%TYPE DEFAULT NULL)
AS
   V_EXISTE_COMP_PADRAO  NUMBER;
   V_EXISTE_COMP_LOCAL   NUMBER;
   V_LOOP_PADRAO         VARCHAR2(1);
   V_LOOP_LOCAL          VARCHAR2(1);
   V_NRPRODUTOS          NUMBER;
   V_RESULT              FILIAL.CDFILIAL%TYPE;
   V_CTRECIT             NUMBER;
   V_CTITPREV            NUMBER;
   V_EXISTEPROD          NUMBER;
   V_QTSOLCONVMN         PREVCONSVMN.QTSOLCONVMN%TYPE;
   V_QTPRODCONVMN        PREVCONSVMN.QTPRODCONVMN%TYPE;
   
BEGIN
   V_LOOP_PADRAO := 'N';
   V_LOOP_LOCAL  := 'N';

   /* INSERE NA ITPREVABASAU O PRODUTO PRINCIPAL COM O CLCULO DA DEMANDA */
   IF P_TIPOTABELA = 'P' THEN
      SELECT COUNT(*) INTO V_CTITPREV
      FROM ITPREVABASAU
      WHERE CDFILIAL     = P_CDFILIAL
        AND NRPREVABASEV = P_NRPREVABASEV
        AND NRMAPABASEV  = P_NRMAPABASEV
        AND CDPRODUTO    = P_CDPRODUTO;

      IF V_CTITPREV = 0 THEN
         INSERT INTO ITPREVABASAU
          (CDFILIAL,NRPREVABASEV,NRMAPABASEV,CDPRODUTO,QTITPRABASAU,QTITSOABASAU)
         VALUES
           (P_CDFILIAL,P_NRPREVABASEV,P_NRMAPABASEV,P_CDPRODUTO,P_QTPRODUTO,P_QTPRODUTO);
      ELSE
         UPDATE ITPREVABASAU
         SET    QTITPRABASAU = QTITPRABASAU + P_QTPRODUTO,
                QTITSOABASAU = QTITSOABASAU + P_QTPRODUTO
         WHERE  CDFILIAL     = P_CDFILIAL
           AND  NRPREVABASEV = P_NRPREVABASEV
           AND  NRMAPABASEV  = P_NRMAPABASEV
           AND  CDPRODUTO    = P_CDPRODUTO;
      END IF;

   END IF;

   /* VERIFICA COMPOSICAO LOCAL */
   SELECT COUNT(*)
   INTO   V_NRPRODUTOS
   FROM   ROTFABLOCAL
   WHERE (CDFILIAL  = P_CDFILIAL ) AND
         (CDPRODUTO = P_CDPRODUTO);

   IF V_NRPRODUTOS > 0 THEN
      V_RESULT := P_CDFILIAL;
   ELSE
      V_RESULT := 'P';
   END IF;

   IF V_RESULT = 'P' THEN

      FOR C_PADRAO IN
        (SELECT
           RB.CDPRODUTO,  RB.CDSUBPRODUTO, RB.QTSUBPRODROT,
           RB.NRHRFABPROD,RB.NRSEQPROD, RB.IDIMPPRODROT,
           PT.NMPRODUTO,  PT.SGUNIDADE,  DR.TXROTFAB as TXINSTR
        FROM
           ROTFABRICA RB, PRODUTO PT, DESCROTEIRO DR
        WHERE
           (RB.CDPRODUTO    = P_CDPRODUTO  ) AND
           (RB.CDSUBPRODUTO = PT.CDPRODUTO  ) AND
           (RB.CDPRODUTO    = DR.CDPRODUTO(+))) LOOP

         SELECT COUNT(*)
         INTO   V_EXISTE_COMP_PADRAO
         FROM   ROTFABRICA
         WHERE (CDPRODUTO = C_PADRAO.CDSUBPRODUTO);

         SELECT COUNT(*)
         INTO   V_EXISTE_COMP_LOCAL
         FROM   ROTFABLOCAL
         WHERE (CDFILIAL  = P_CDFILIAL       ) AND
               (CDPRODUTO = C_PADRAO.CDSUBPRODUTO);

         IF (V_EXISTE_COMP_PADRAO > 0) OR (V_EXISTE_COMP_LOCAL > 0) THEN
            INSERE_ITEMPREV(P_CDFILIAL, P_NRPREVABASEV,P_NRMAPABASEV, C_PADRAO.CDSUBPRODUTO,
                            (C_PADRAO.QTSUBPRODROT * P_QTPRODUTO),P_TIPOTABELA,P_DTPREVENDVMN,P_NRABASTEROTA);
         ELSE
            IF P_TIPOTABELA = 'P' THEN
               SELECT COUNT(*) INTO V_CTITPREV
               FROM ITPREVABAMAP
               WHERE CDFILIAL     = P_CDFILIAL
                 AND NRPREVABASEV = P_NRPREVABASEV
                 AND NRMAPABASEV  = P_NRMAPABASEV
                 AND CDPRODUTO    = C_PADRAO.CDSUBPRODUTO;

               IF V_CTITPREV = 0 THEN
                  INSERT INTO ITPREVABAMAP
                   (CDFILIAL, NRPREVABASEV, NRMAPABASEV, CDPRODUTO, QTITPRABAMAP)
                  VALUES
                   (P_CDFILIAL, P_NRPREVABASEV, P_NRMAPABASEV, C_PADRAO.CDSUBPRODUTO, (C_PADRAO.QTSUBPRODROT * P_QTPRODUTO));
               ELSE
                  UPDATE ITPREVABAMAP
                  SET    QTITPRABAMAP = QTITPRABAMAP + (C_PADRAO.QTSUBPRODROT * P_QTPRODUTO)
                  WHERE  CDFILIAL     = P_CDFILIAL
                    AND  NRPREVABASEV = P_NRPREVABASEV
                    AND  NRMAPABASEV  = P_NRMAPABASEV
                    AND  CDPRODUTO    = C_PADRAO.CDSUBPRODUTO;
               END IF;
            END IF;

            IF P_TIPOTABELA = 'M' THEN
               SELECT COUNT(*) INTO V_CTRECIT
               FROM RECITEMAPABA
               WHERE CDFILIAL    = P_CDFILIAL
                 AND NRMAPABASEV = P_NRMAPABASEV
                 AND CDPRODUTO   = C_PADRAO.CDSUBPRODUTO;

               IF V_CTRECIT = 0 THEN
                  INSERT INTO RECITEMAPABA
                   (CDFILIAL, NRMAPABASEV,CDPRODUTO)
                  VALUES
                   (P_CDFILIAL,P_NRMAPABASEV,C_PADRAO.CDSUBPRODUTO);
               END IF;
            END IF;

            IF P_TIPOTABELA = 'C' THEN
               V_QTPRODCONVMN := (C_PADRAO.QTSUBPRODROT * P_QTPRODUTO);
               IF V_QTPRODCONVMN < 0 THEN
                  V_QTSOLCONVMN := 0;
               ELSE
                  V_QTSOLCONVMN := V_QTPRODCONVMN;
               END IF;

               SELECT COUNT(*) INTO V_EXISTEPROD
               FROM   PREVCONSVMN
               WHERE CDFILIALCLIE = P_CDFILIAL
                 AND DTPREVENDVMN = P_DTPREVENDVMN
                 AND CDPRODUTO    = P_CDPRODUTO
                 AND CDSUBPRODVMN = C_PADRAO.CDSUBPRODUTO;

               IF V_EXISTEPROD = 0 THEN
                  INSERT INTO PREVCONSVMN
                   (CDFILIALCLIE,DTPREVENDVMN,CDPRODUTO,CDSUBPRODVMN,QTPRODCONVMN,QTSOLCONVMN)
                  VALUES
                   (P_CDFILIAL,P_DTPREVENDVMN,P_CDPRODUTO,C_PADRAO.CDSUBPRODUTO,V_QTPRODCONVMN,V_QTSOLCONVMN);
               ELSE
                  UPDATE PREVCONSVMN
                  SET QTSOLCONVMN = V_QTSOLCONVMN
                  WHERE CDFILIALCLIE = P_CDFILIAL
                    AND DTPREVENDVMN = P_DTPREVENDVMN
                    AND CDPRODUTO    = P_CDPRODUTO
                    AND CDSUBPRODVMN = C_PADRAO.CDSUBPRODUTO;
               END IF;
            END IF;

            /* TIPO A - INSERE NA TABELA ITABASTEROTA */
            IF P_TIPOTABELA = 'A' THEN
               SELECT COUNT(*) INTO V_EXISTEPROD
               FROM   ITABASTEROTA
               WHERE CDFILIAL     = P_CDFILIAL
                 AND NRABASTEROTA = P_NRABASTEROTA
                 AND CDPRODUTO    = C_PADRAO.CDSUBPRODUTO;

               IF V_EXISTEPROD = 0 THEN
                  INSERT INTO ITABASTEROTA
                   (CDFILIAL,NRABASTEROTA,CDPRODUTO,QTENTRABAROT,QTABASABAROT,QTDEVOABAROT,QTENTSITEROT)
                  VALUES
                   (P_CDFILIAL,P_NRABASTEROTA,C_PADRAO.CDSUBPRODUTO,(C_PADRAO.QTSUBPRODROT*P_QTPRODUTO),0,0,0);
               ELSE
                  UPDATE ITABASTEROTA
                  SET    QTENTRABAROT = QTENTRABAROT + (C_PADRAO.QTSUBPRODROT*P_QTPRODUTO)
                  WHERE  CDFILIAL     = P_CDFILIAL
                    AND  NRABASTEROTA = P_NRABASTEROTA
                    AND  CDPRODUTO    = C_PADRAO.CDSUBPRODUTO;
               END IF;
            END IF;

            /* TIPO E - INSERE NA TABELA ITPREVABASEV */
            IF P_TIPOTABELA = 'E' THEN
               SELECT COUNT(*) INTO V_EXISTEPROD
               FROM   ITPREVABASEV
               WHERE CDFILIAL     = P_CDFILIAL
                 AND NRPREVABASEV = P_NRPREVABASEV
                 AND CDPRODUTO    = C_PADRAO.CDSUBPRODUTO;

               IF V_EXISTEPROD = 0 THEN
                  INSERT INTO ITPREVABASEV
                   (CDFILIAL,NRPREVABASEV,CDPRODUTO,QTITPRABASEV,IDTPLANPRABA,QTITSOABASEV)
                  VALUES
                   (P_CDFILIAL,P_NRPREVABASEV,C_PADRAO.CDSUBPRODUTO,(C_PADRAO.QTSUBPRODROT*P_QTPRODUTO),'A',(C_PADRAO.QTSUBPRODROT*P_QTPRODUTO));
               ELSE
                  UPDATE ITPREVABASEV
                  SET    QTITPRABASEV = QTITPRABASEV + (C_PADRAO.QTSUBPRODROT*P_QTPRODUTO),
                         QTITSOABASEV = QTITSOABASEV + (C_PADRAO.QTSUBPRODROT*P_QTPRODUTO)
                  WHERE  CDFILIAL     = P_CDFILIAL
                    AND  NRPREVABASEV = P_NRPREVABASEV
                    AND  CDPRODUTO    = C_PADRAO.CDSUBPRODUTO;
               END IF;
            END IF;

         END IF;
         V_LOOP_PADRAO := 'S';
      END LOOP;
   ELSE     /* COMPOSICAO LOCAL */
      FOR C_LOCAL IN
         (SELECT
            RL.CDFILIAL, RL.CDPRODUTO, RL.CDSUBPRODLOC AS CDSUBPRODUTO,
            RL.QTSUBPRODLOC AS QTSUBPRODROT,
            RL.NRHRFABPRLOC AS NRHRFABPROD, RL.IDIMPPROTLOC AS IDIMPPRODROT,
            RL.NRSEQPRODLOC AS NRSEQPROD,
            PT.NMPRODUTO, PT.SGUNIDADE,
            DL.TXROTFABLOC AS TXINSTR
         FROM
            ROTFABLOCAL RL, PRODUTO PT, DESCROTLOCAL DL
         WHERE
            (RL.CDSUBPRODLOC = PT.CDPRODUTO   ) AND
            (RL.CDFILIAL     = DL.CDFILIAL(+) ) AND
            (RL.CDPRODUTO    = DL.CDPRODUTO(+)) AND
            (RL.CDFILIAL     = P_CDFILIAL     )  AND
            (RL.CDPRODUTO    = P_CDPRODUTO    )) LOOP

         SELECT COUNT(*)
         INTO   V_EXISTE_COMP_PADRAO
         FROM   ROTFABRICA
         WHERE (CDPRODUTO = C_LOCAL.CDSUBPRODUTO);

         SELECT COUNT(*)
         INTO   V_EXISTE_COMP_LOCAL
         FROM   ROTFABLOCAL
         WHERE (CDFILIAL  = P_CDFILIAL       ) AND
               (CDPRODUTO = C_LOCAL.CDSUBPRODUTO);

         IF (V_EXISTE_COMP_PADRAO > 0) OR (V_EXISTE_COMP_LOCAL > 0) THEN
             INSERE_ITEMPREV(P_CDFILIAL, P_NRPREVABASEV,P_NRMAPABASEV, C_LOCAL.CDSUBPRODUTO,
                             (C_LOCAL.QTSUBPRODROT * P_QTPRODUTO), P_TIPOTABELA,P_DTPREVENDVMN,P_NRABASTEROTA);
         ELSE
            IF P_TIPOTABELA = 'P' THEN
              SELECT COUNT(*) INTO V_CTITPREV
              FROM ITPREVABAMAP
              WHERE CDFILIAL     = P_CDFILIAL
                AND NRPREVABASEV = P_NRPREVABASEV
                AND NRMAPABASEV  = P_NRMAPABASEV
                AND CDPRODUTO    = C_LOCAL.CDSUBPRODUTO;

              IF V_CTITPREV = 0 THEN
                 INSERT INTO ITPREVABAMAP
                  (CDFILIAL, NRPREVABASEV, NRMAPABASEV,CDPRODUTO, QTITPRABAMAP)
                 VALUES
                  (P_CDFILIAL, P_NRPREVABASEV, P_NRMAPABASEV, C_LOCAL.CDSUBPRODUTO, (C_LOCAL.QTSUBPRODROT * P_QTPRODUTO));
              ELSE
                 UPDATE ITPREVABAMAP
                 SET    QTITPRABAMAP = QTITPRABAMAP + (C_LOCAL.QTSUBPRODROT * P_QTPRODUTO)
                 WHERE  CDFILIAL     = P_CDFILIAL
                   AND  NRPREVABASEV = P_NRPREVABASEV
                   AND  NRMAPABASEV  = P_NRMAPABASEV
                   AND  CDPRODUTO    = C_LOCAL.CDSUBPRODUTO;
              END IF;
            END IF;

            IF P_TIPOTABELA = 'M' THEN
               SELECT COUNT(*) INTO V_CTRECIT
               FROM RECITEMAPABA
               WHERE CDFILIAL    = P_CDFILIAL
                 AND NRMAPABASEV = P_NRMAPABASEV
                 AND CDPRODUTO   = C_LOCAL.CDSUBPRODUTO;

               IF V_CTRECIT = 0 THEN
                  INSERT INTO RECITEMAPABA
                   (CDFILIAL, NRMAPABASEV,CDPRODUTO)
                  VALUES
                   (P_CDFILIAL,P_NRMAPABASEV,C_LOCAL.CDSUBPRODUTO);
               END IF;
            END IF;

            IF P_TIPOTABELA = 'C' THEN
               V_QTPRODCONVMN := (C_LOCAL.QTSUBPRODROT * P_QTPRODUTO);
               IF V_QTPRODCONVMN < 0 THEN
                  V_QTSOLCONVMN := 0;
               ELSE
                  V_QTSOLCONVMN := V_QTPRODCONVMN;
               END IF;

               SELECT COUNT(*) INTO V_EXISTEPROD
               FROM   PREVCONSVMN
               WHERE CDFILIALCLIE = P_CDFILIAL
                 AND DTPREVENDVMN = P_DTPREVENDVMN
                 AND CDPRODUTO    = P_CDPRODUTO
                 AND CDSUBPRODVMN = C_LOCAL.CDSUBPRODUTO;

               IF V_EXISTEPROD = 0 THEN
                  INSERT INTO PREVCONSVMN
                   (CDFILIALCLIE,DTPREVENDVMN,CDPRODUTO,CDSUBPRODVMN,QTPRODCONVMN,QTSOLCONVMN)
                  VALUES
                   (P_CDFILIAL,P_DTPREVENDVMN,P_CDPRODUTO,C_LOCAL.CDSUBPRODUTO,V_QTPRODCONVMN,V_QTSOLCONVMN);
               ELSE
                  UPDATE PREVCONSVMN
                  SET QTSOLCONVMN = V_QTSOLCONVMN
                  WHERE CDFILIALCLIE = P_CDFILIAL
                    AND DTPREVENDVMN = P_DTPREVENDVMN
                    AND CDPRODUTO    = P_CDPRODUTO
                    AND CDSUBPRODVMN = C_LOCAL.CDSUBPRODUTO;
               END IF;
            END IF;

            /* TIPO A - INSERE NA TABELA ITABASTEROTA  */
            IF P_TIPOTABELA = 'A' THEN
               SELECT COUNT(*) INTO V_EXISTEPROD
               FROM   ITABASTEROTA
               WHERE CDFILIAL     = P_CDFILIAL
                 AND NRABASTEROTA = P_NRABASTEROTA
                 AND CDPRODUTO    = C_LOCAL.CDSUBPRODUTO;

               IF V_EXISTEPROD = 0 THEN
                  INSERT INTO ITABASTEROTA
                   (CDFILIAL,NRABASTEROTA,CDPRODUTO,QTENTRABAROT,QTABASABAROT,QTDEVOABAROT,QTENTSITEROT)
                  VALUES
                   (P_CDFILIAL,P_NRABASTEROTA,C_LOCAL.CDSUBPRODUTO,(C_LOCAL.QTSUBPRODROT*P_QTPRODUTO),0,0,0);
               ELSE
                  UPDATE ITABASTEROTA
                  SET    QTENTRABAROT = QTENTRABAROT + (C_LOCAL.QTSUBPRODROT * P_QTPRODUTO)
                  WHERE  CDFILIAL     = P_CDFILIAL
                    AND  NRABASTEROTA = P_NRABASTEROTA
                    AND  CDPRODUTO    = C_LOCAL.CDSUBPRODUTO;
               END IF;
            END IF;

            /* TIPO E - INSERE NA TABELA ITPREVABASEV */
            IF P_TIPOTABELA = 'E' THEN
               SELECT COUNT(*) INTO V_EXISTEPROD
               FROM   ITPREVABASEV
               WHERE CDFILIAL     = P_CDFILIAL
                 AND NRPREVABASEV = P_NRPREVABASEV
                 AND CDPRODUTO    = C_LOCAL.CDSUBPRODUTO;

               IF V_EXISTEPROD = 0 THEN
                  INSERT INTO ITPREVABASEV
                   (CDFILIAL,NRPREVABASEV,CDPRODUTO,QTITPRABASEV,IDTPLANPRABA,QTITSOABASEV)
                  VALUES
                   (P_CDFILIAL,P_NRPREVABASEV,C_LOCAL.CDSUBPRODUTO,(C_LOCAL.QTSUBPRODROT*P_QTPRODUTO),'A',(C_LOCAL.QTSUBPRODROT*P_QTPRODUTO));
               ELSE
                  UPDATE ITPREVABASEV
                  SET    QTITPRABASEV = QTITPRABASEV + (C_LOCAL.QTSUBPRODROT*P_QTPRODUTO),
                         QTITSOABASEV = QTITSOABASEV + (C_LOCAL.QTSUBPRODROT*P_QTPRODUTO)
                  WHERE  CDFILIAL     = P_CDFILIAL
                    AND  NRPREVABASEV = P_NRPREVABASEV
                    AND  CDPRODUTO    = C_LOCAL.CDSUBPRODUTO;
               END IF;
            END IF;

         END IF;
         V_LOOP_LOCAL  := 'S';
      END LOOP;
   END IF;

   /* SE NO TIVER COMPOSIO NENHUMA NEM PADRAO E NEM LOCAL INCLUI O PRPRIO PRODUTO */
   IF (V_LOOP_PADRAO = 'N') AND (V_LOOP_LOCAL = 'N') AND (P_TIPOTABELA = 'P') THEN
      SELECT COUNT(*) INTO V_CTITPREV
      FROM  ITPREVABAMAP
      WHERE CDFILIAL     = P_CDFILIAL
        AND NRPREVABASEV = P_NRPREVABASEV
        AND NRMAPABASEV  = P_NRMAPABASEV
        AND CDPRODUTO    = P_CDPRODUTO;

      IF V_CTITPREV = 0 THEN
         INSERT INTO ITPREVABAMAP
          (CDFILIAL, NRPREVABASEV, NRMAPABASEV,CDPRODUTO, QTITPRABAMAP)
         VALUES
          (P_CDFILIAL, P_NRPREVABASEV, P_NRMAPABASEV,P_CDPRODUTO, P_QTPRODUTO);
      ELSE
         UPDATE ITPREVABAMAP
         SET    QTITPRABAMAP = QTITPRABAMAP + P_QTPRODUTO
         WHERE  CDFILIAL     = P_CDFILIAL
           AND  NRPREVABASEV = P_NRPREVABASEV
           AND  NRMAPABASEV  = P_NRMAPABASEV
           AND  CDPRODUTO    = P_CDPRODUTO;
      END IF;
   END IF;

   /* SE NO TIVER COMPOSIO NENHUMA INCLUI O PRPRIO PRODUTO */
   IF (V_LOOP_PADRAO = 'N') AND (V_LOOP_LOCAL = 'N') AND (P_TIPOTABELA = 'C') THEN
      IF P_QTPRODUTO < 0 THEN
         V_QTSOLCONVMN := 0;
      ELSE
         V_QTSOLCONVMN := P_QTPRODUTO;
      END IF;

      SELECT COUNT(*) INTO V_EXISTEPROD
      FROM   PREVCONSVMN
      WHERE CDFILIALCLIE = P_CDFILIAL
        AND DTPREVENDVMN = P_DTPREVENDVMN
        AND CDPRODUTO    = P_CDPRODUTO
        AND CDSUBPRODVMN = P_CDPRODUTO;

      IF V_EXISTEPROD = 0 THEN
         INSERT INTO PREVCONSVMN
          (CDFILIALCLIE,DTPREVENDVMN,CDPRODUTO,CDSUBPRODVMN,QTPRODCONVMN,QTSOLCONVMN)
         VALUES
          (P_CDFILIAL,P_DTPREVENDVMN,P_CDPRODUTO,P_CDPRODUTO,P_QTPRODUTO,V_QTSOLCONVMN);
      ELSE
         UPDATE PREVCONSVMN
         SET   QTSOLCONVMN  = V_QTSOLCONVMN
         WHERE CDFILIALCLIE = P_CDFILIAL
           AND DTPREVENDVMN = P_DTPREVENDVMN
           AND CDPRODUTO    = P_CDPRODUTO
           AND CDSUBPRODVMN = P_CDPRODUTO;
      END IF;
   END IF;

   /* SE NO TIVER COMPOSIO NENHUMA INCLUI O PRPRIO PRODUTO NA ITABASTEROTA */
   IF (V_LOOP_PADRAO = 'N') AND (V_LOOP_LOCAL = 'N') AND (P_TIPOTABELA = 'A') THEN
      SELECT COUNT(*) INTO V_CTITPREV
      FROM  ITABASTEROTA
      WHERE CDFILIAL     = P_CDFILIAL
        AND NRABASTEROTA = P_NRABASTEROTA
        AND CDPRODUTO    = P_CDPRODUTO;

      IF V_CTITPREV = 0 THEN
         INSERT INTO ITABASTEROTA
          (CDFILIAL,NRABASTEROTA,CDPRODUTO,QTENTRABAROT,QTABASABAROT,QTDEVOABAROT,QTENTSITEROT)
         VALUES
          (P_CDFILIAL,P_NRABASTEROTA,P_CDPRODUTO,P_QTPRODUTO,0,0,0);
      ELSE
         UPDATE ITABASTEROTA
         SET    QTENTRABAROT = QTENTRABAROT + P_QTPRODUTO
         WHERE  CDFILIAL     = P_CDFILIAL
           AND  NRABASTEROTA = P_NRABASTEROTA
           AND  CDPRODUTO    = P_CDPRODUTO;
      END IF;
   END IF;

   /* SE NO TIVER COMPOSIO NENHUMA INCLUI O PRPRIO PRODUTO NA ITABASTEROTA */
   IF (V_LOOP_PADRAO = 'N') AND (V_LOOP_LOCAL = 'N') AND (P_TIPOTABELA = 'E') THEN
      SELECT COUNT(*) INTO V_EXISTEPROD
      FROM   ITPREVABASEV
      WHERE CDFILIAL     = P_CDFILIAL
        AND NRPREVABASEV = P_NRPREVABASEV
        AND CDPRODUTO    = P_CDPRODUTO;

      IF V_EXISTEPROD = 0 THEN
         INSERT INTO ITPREVABASEV
          (CDFILIAL,NRPREVABASEV,CDPRODUTO,QTITPRABASEV,IDTPLANPRABA,QTITSOABASEV)
         VALUES
          (P_CDFILIAL,P_NRPREVABASEV,P_CDPRODUTO,P_QTPRODUTO,'A',P_QTPRODUTO);
      ELSE
         UPDATE ITPREVABASEV
         SET    QTITPRABASEV = QTITPRABASEV + P_QTPRODUTO,
                QTITSOABASEV = QTITSOABASEV + P_QTPRODUTO
         WHERE  CDFILIAL     = P_CDFILIAL
           AND  NRPREVABASEV = P_NRPREVABASEV
           AND  CDPRODUTO    = P_CDPRODUTO;
      END IF;

   END IF;

END;
/

