export class FileUpload {
  public static async getFileContent(file: any) {
    const fileContent: any = await this.fileContent(file);
    return {
      content: fileContent,
      lastModified: file.lastModified,
      lastModifiedDate: file.lastModifiedDate,
      name: file.name,
      size: file.size,
      type: file.type,
      webkitRelativePath: file.webkitRelativePath,
    };
  }

  public static async fileContent(file: any) {
    return new Promise((resolve, reject) => {
      const reader = new FileReader();
      reader.readAsText(file); // eslint-disable-next-line
      reader.onload = async function (f) {
        if (f.target !== null) {
          const result = await FileUpload.splitFileContent(f.target.result);
          resolve(result);
        }
      };
      reader.onerror = (error) => reject(error);
    });
  }

  public static async splitFileContent(file: any) {
    const arrayFile: any[] = file.split('\r\n');
    const result: any[] = [];
    const itens: any[] = [];
    
    for (let a = 0; a < arrayFile.length; a += 1) {
      const item = {
        IDENTIFICADOR: arrayFile[a].substring(0, 1).trim(),
        COD_PRODUTO_ANT: arrayFile[a].substring(1, 11).trim(),
        DESCR_PRODUTO: arrayFile[a].substring(11, 61).trim(),
        QTDE_PRODUTO: arrayFile[a].substring(61, 65).trim(),
        VLR_UNITARIO: arrayFile[a].substring(65, 78).trim(),
        PESO_LIQ_ITEM: arrayFile[a].substring(78, 88).trim(),
        NUM_PEDIDO: arrayFile[a].substring(88, 98).trim(),
        PLACA_VEICULO: arrayFile[a].substring(98, 109).trim(),
        COD_PRODUTO: arrayFile[a].substring(109, 129).trim(),
        QTDE_VOLUMES: arrayFile[a].substring(129, 139).trim(),
        NUM_LOTE_FABR: arrayFile[a].substring(139, 149).trim(),
        DATA_VALIDADE: arrayFile[a].substring(149, 157).trim(),
        PESO_BRT_ITEM: arrayFile[a].substring(157, 167).trim(),
        QTDE_FATURADA: arrayFile[a].substring(167, 177).trim(),
        EMBALAGEMVALOR: arrayFile[a].substring(177, 180).trim(),
        EMBALAGEMPEDIDO: arrayFile[a].substring(180, 183).trim(),
        NUM_EMBARQUE: arrayFile[a].substring(183, 233).trim(),
        ITEM_PEDIDO_CLI: arrayFile[a].substring(233, 239).trim(),
      };
      
      itens.push(item);
    }
    
    result.push(itens);

    return result;
  }
}
